/*
 *
 * ATM Switch Control Library - swctl
 * 	by miwa@mt.cs.keio.ac.jp, 1997
 * $Id: swctl_snmp.h,v 1.1.4.1 1998/09/02 04:02:27 onoe Exp $
 *
 */

#ifndef	_SWCTL_SNMP_H_
#define	_SWCTL_SNMP_H_

typedef	u_long		miboid;		/* mib object id */

/* mib object structure */

typedef struct _swctl_mib_object_t {

    struct _swctl_mib_object_t	*next_object;	/* linked list */
    miboid			*name;		/* mib object id */
    int				name_length;	/* mib object id length */
    int				value;		/* mib object value */

} swctl_mib_object_t;

/* snmp error codes & specific variables */

#define	SNMP_SUCCESS		0
#define	SNMP_LOCAL_FAILURE	-1
#define	SNMP_PARAM_FAILURE	-2
#define	SNMP_TIMEOUT		-3

#define	SNMP_VALID_VAL		1
#define	SNMP_REQ_VAL		2
#define	SNMP_UNDER_VAL		3
#define	SNMP_INVALID_VAL	4

#define SNMP_PROTO_OTHER	1
#define	SNMP_PROTO_SPANS	2
#define	SNMP_PROTO_Q2931	3
#define	SNMP_PROTO_PVC		4
#define SNMP_PROTO_SPVC		5

/* mib object ids */

#define	SNMP_VCC_ROOT_LENGTH	14
#define	SNMP_VCC_PREFIX_LENGTH	15
#define	SNMP_UPC_ROOT_LENGTH	14
#define	SNMP_UPC_PREFIX_LENGTH	15

static u_long SNMP_VCC_ROOT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1};

static u_long SNMP_VCC_INPORT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,1};
static u_long SNMP_VCC_INVPI_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,2};
static u_long SNMP_VCC_INVCI_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,3};
static u_long SNMP_VCC_OUTPORT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,4};
static u_long SNMP_VCC_OUTVPI_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,5};
static u_long SNMP_VCC_OUTVCI_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,6};
static u_long SNMP_VCC_STAT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,7};
static u_long SNMP_VCC_PROTO_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,2,1,8};

static u_long SNMP_VCC_STATUS_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,1,1,4};
static u_long SNMP_VCC_CELL_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,1,1,8};
static u_long SNMP_VCC_REJECT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,1,1,11};
static u_long SNMP_VCC_UPC_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,4,1,1,14};

static u_long SNMP_UPC_ROOT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1};
static u_long SNMP_UPC_KEY_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,1};
static u_long SNMP_UPC_STAT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,2};
static u_long SNMP_UPC_PCR01_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,3};
static u_long SNMP_UPC_SCR01_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,4};
static u_long SNMP_UPC_MBS01_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,5};
static u_long SNMP_UPC_PCR0_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,6};
static u_long SNMP_UPC_SCR0_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,7};
static u_long SNMP_UPC_MBS0_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,8};
static u_long SNMP_UPC_CDVT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,9};
static u_long SNMP_UPC_ACT_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,10};
static u_long SNMP_UPC_AAL5EPD_PREFIX[]={1,3,6,1,4,1,326,2,2,2,1,10,1,1,11};

/* swctlget.c */
int swctl_snmp_get __P((struct snmp_session *in_session,
			swctl_mib_object_t *mib_object_list,
			swctl_mib_object_t **mib_object_list_p));

/* swctlset.c */
int swctl_snmp_set __P((struct snmp_session *in_session,
			swctl_mib_object_t *mib_object_list,
			swctl_mib_object_t **mib_object_list_p));
int snmp_add_var_int __P((struct snmp_pdu *pdu, miboid *name, int name_length,
			  int value));
int swctl_snmp_set_gauge __P((struct snmp_session *session,
			      swctl_mib_object_t *mib_object_list,
			      swctl_mib_object_t **mib_object_list_p));
int snmp_add_var_gauge __P((struct snmp_pdu *pdu, miboid *name,
			    int name_length, u_long value));

/* swctlbulkwalk.c */
int swctl_snmp_bulkwalk __P((struct snmp_session *in_session,
			     miboid *root, int rootlen,
			     swctl_mib_object_t **mib_object_list_p));
/* swctltool.c */
int copy_variable __P((miboid *obj_name, int name_length, struct
		       variable_list *variable,
		       swctl_mib_object_t *mib_object)); 
int clean_junk_object __P((struct snmp_session *session, swctl_mib_object_t 
			   *mib_object_list));
swctl_mib_object_t *make_mib_object __P((miboid *prefix, int prefix_len,
					 miboid *suffix, int suffix_len,
					 int value));
int object_prefix_cmp __P((miboid *src_name, int src_name_length,
			   miboid *cmp_name, int cmp_name_length));
int free_mib_object_list __P((swctl_mib_object_t *mib_object_list));

/* swctlsw.c */
swctl_switch_attr_t *switch_attr_search __P((swctl_switch_attr_t
					     *sw_attr_list, switch_id_t sw));
swctl_switch_attr_t *switch_attr_delete __P((swctl_switch_attr_t
					     *sw_attr_list, switch_id_t sw));

/* swctlvcc.c */
swctl_mib_object_t *make_vcc_rt_object __P((miboid *prefix, int prefix_len,
					    swctl_addr_t addr1,
					    swctl_addr_t addr2,
					    int value));
swctl_mib_object_t *make_vcc_object __P((miboid *prefix,
					 int prefix_len,
					 swctl_addr_t addr,
					 int value));
int print_vcc_table __P((swctl_vcc_table_t *vcc_table));
int print_vcc_table_list __P((swctl_vcc_table_t *vcc_table_list));
int free_vcc_table_list __P((swctl_vcc_table_t *vcc_table_list));

/* swctlupc.c */
int upc_search_param2index __P((swctl_upc_table_t *upc_table_list,
				swctl_param_t *param, int *upc_index));
swctl_upc_table_t *upc_search_index2table __P((swctl_upc_table_t
					       *upc_table_list,
					       int upc_index));
swctl_upc_table_t *upc_index_entry __P((swctl_upc_table_t *upc_table_list,
					int upc_index, swctl_param_t *param));
swctl_upc_table_t *upc_index_delete __P((swctl_upc_table_t *upc_table_list,
					 int upc_index));
swctl_mib_object_t *make_upc_object __P((miboid *prefix, int prefix_len,
					 int upc_index, int value));
swctl_mib_object_t *make_upc_object_list __P((int upc_index,
					      swctl_param_t *param));
int print_upc_table __P((swctl_upc_table_t *upc_table));
int print_upc_table_list __P((swctl_upc_table_t *upc_table_list));
int free_upc_table_list __P((swctl_upc_table_t *upc_table_list));

#endif	/* _SWCTL_SNMP_H_ */
