/*
 *
 * ATM Switch Control Library - swctl
 * 	by miwa@mt.cs.keio.ac.jp, 1997
 * $Id: swctltrap.c,v 1.1.4.1 1998/09/02 04:02:31 onoe Exp $
 *
 */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <ctype.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "swctl.h"

static u_long	swview_host = 0;
static u_short	swview_port = 0;

int swview_init(u_long addr, u_short port)
{
    swview_host = addr;
    swview_port = port;

    return(SWCTL_SUCCESS);
}

int swctl_trap(switch_id_t sw)
{
    int sockfd;
    struct sockaddr_in sinLocal, sinRemote;
    struct hostent *hostentry;
    
    if( 0 > (sockfd = socket( AF_INET, SOCK_DGRAM, 0 )))
	return(SWCTL_LOCAL_FAILURE);

    bzero((char *) &sinLocal, sizeof(struct sockaddr_in));
    sinLocal.sin_family = AF_INET;
    sinLocal.sin_addr.s_addr = htonl(INADDR_ANY);
    sinLocal.sin_port = htons(0);

    if( 0 > bind( sockfd, (struct sockaddr *)&sinLocal, sizeof( struct
						       sockaddr_in )))
	return(SWCTL_LOCAL_FAILURE); 

    bzero((char *) &sinRemote, sizeof(struct sockaddr_in));
    sinRemote.sin_family = AF_INET;

    if( swview_host )
      sinRemote.sin_addr.s_addr   = swview_host;
    else if( getenv("SWVIEW_HOST")
	    && (struct hostent *)NULL
	    != (hostentry = (struct hostent
			     *)gethostbyname(getenv("SWVIEW_HOST"))) ) {
	sinRemote.sin_addr.s_addr
	  = (*((struct in_addr *)(hostentry->h_addr))).s_addr;
    }
    else
      sinRemote.sin_addr.s_addr   = inet_addr(DEFAULT_SWVIEW_HOST);
    
    if( swview_port )
      sinRemote.sin_port = swview_port;
    else if( getenv("SWVIEW_PORT") )
      sinRemote.sin_port = htons(atoi(getenv("SWVIEW_PORT")));
    else
      sinRemote.sin_port = htons(DEFAULT_SWVIEW_PORT);

    if( 0 > sendto( sockfd, (void *)&sw, sizeof(switch_id_t), 0,
	   (struct sockaddr *)&sinRemote, sizeof(struct sockaddr_in)))
	return(SWCTL_LOCAL_FAILURE);

    if( 0 > close(sockfd))
	return(SWCTL_LOCAL_FAILURE);

    return(SWCTL_SUCCESS);
}
